# Area.py
#
# 9.3  Monte Carlo Simulation to Model Deterministic Behavior
#
# Introduction to Computational Science:  Modeling and Simulation for the Sciences
# Angela B. Shiflet and George W. Shiflet
# Wofford College
# Copyright 2006 by Princeton University Press
#
# Monte Carlo simulation to find the area under a curve that is
# above the x-axis from x = a to x = b
#
# For example, find area under f(x) = a between x = 2 and x = 3.
#

from graphics import *
from random import random

# Define f

def main():
# Plot f from 2 to 3

# We generate random floating point y values between 0 and 9 and corresponding
# random floating point x values between 2 and 3.  For each pair, we determine
# if the random y value is below the function at the random x value.  If so,
# we consider that the "dart" with coordinates of the random x and y values hit
# below the curve.  Generate a table,  dartTbl, of ten 0s and 1s so that an
# entry is 1 if a random y value is less than the function at a random x value
# and that the element is 0 otherwise.

# Calculate the fraction (fractionUnder) of darts that hit under the curve.

# Calculate the area (rectArea) of the rectangular dartboard.

# Determine an estimate for the area under the curve between 2 and 3.

# We get a better estimate if we use more "darts."  Copy the statements that 
# assign values to dartTbl, fractionUnder, rectArea, and area into one cell. 
# Revise the statement that assigns a value to dartTbl to generate a table of 
# 1000 values but not to display the result.  Execute the subsequent commands to
# obtain a better estinate of the area under the curve.

# We obtain a better result if we perform this process a number of times and 
# calculate the average (mean) area.  The standard deviation gives an indication 
# of how good the result is.  

# Generate a 100-by-100 table of 0s and 1s, where each row consists of one 
# simulation of throwing 100 darts.

# Calculate the fraction (fractionUnder) of darts that hit under the curve for 
# each row (simulation), placing the results in a list.

# Load the math package.

# Find the mean and standard deviation of the results for our simulations, and 
# express the answers as floating point numbers.

# Repeat the process for the transpose

# Take the transpose of dartTbls.

# Calculate the fraction (fractionUnder) of darts that hit under the curve for 
# each row (simulation), placing the results in a list.

# Find the mean and standard deviation of our simulation results, and express 
# the answers as floating point numbers.

# Estimate the area using values from the entire table

# Flatten the table dartTbls.

# Calculate the fraction (fractionUnder) of darts that hit under the curve for 
# the entire table (simulation), and find the area as a floating point number.


main()
    
